#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_FieldParameter.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_FieldParameter> Fish_FieldParameter::msSingleton(nullptr);

int Fish_FieldParameter::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FieldParameterData* Fish_FieldParameter::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_FieldParameterData>& Fish_FieldParameter::GetMapData()
{
	return mMapData;
}

void Fish_FieldParameter::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_FieldParameter::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FieldParameterData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomId = element->IntAttribute("RoomId");
		data.mBuffType = element->IntAttribute("BuffType");
		data.mNumber = element->IntAttribute("Number");
		data.mRateOfReturn = element->IntAttribute("RateOfReturn");
		data.mProbability = element->IntAttribute("Probability");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_FieldParameter::Load()
{
	Load("../Config/Fish_FieldParameter.xml");
}

Fish_FieldParameter* Fish_FieldParameter::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FieldParameter());
	}
	return msSingleton.get();
}
